#define BARNEY .6f, .4f, .7f


/*  a macro for telling which windows need to be fit to their extrema */
#define GFNH_NEEDS_FITTING(i)   ( gWindowsArray[i]->WindowID == 3  || gWindowsArray[i]->WindowID == 4 || gWindowsArray[i]->WindowID == 5 || gWindowsArray[i]->WindowID == 6 )

/*  global variables for handling changes in leaf number */
GLOB int gNewNumLeavesRequested;
GLOB int gNewNumLeaves;
GLOB int gOldNumLeaves;


/*  a global pointer that can be used to access the current AR_graph */
/*  and some other global pointers */
GLOB AR_graph_struct *gA;
GLOB parm_struct *gP;
GLOB haptype_anal_struct *gH;

/*  a global counter of the number of trees gone by */
GLOB int gCtr;

/*  a global variable that records the highest tree so far */
/*  value gets set in gfhtDrawMainScene */
GLOB double gTallestTree = 0.0;
GLOB void gfhtDrawProbTree2Higher(void);

/*  prototypes */

/*  window callback drawing functions */
GLOB void gfhtDrawMainScene(void);
GLOB void gfhtDrawConsoleWindow(void);
void gfhtDrawWaitingToFirstRecomb(void);
GLOB void gfhtNumVisiBreaks(void);
GLOB void gfhtNumShiftsBetweenMRCAs(void);
GLOB void gfhtZoomableTree();
GLOB void gfhtControlNumLeaves(void);

/*  other drawing routines */
GLOB void gfhtDrawMappedARG_rect(AR_graph_struct *A);
GLOB void gfhtDrawARG_seg(AR_graph_struct *A, double Lo, double Hi, double R, double G,
		double B, clipping_struct *CL);
GLOB void gfhtDrawARG_point(AR_graph_struct *A, double x, double R, double G, double B, clipping_struct *CL);
GLOB void gfhtDrawSlashes(GLfloat Vert, GLfloat Height, double *Values, int Num);
GLOB void gfhtDrawSegRectangles(GLfloat Vert, GLfloat Height, GLfloat Lo, GLfloat Hi, double *Values, int Num);
GLOB void gfhtDrawPopSizes(void);
GLOB void gfnhDrawNotValid(void);


/*  callbacks and such for the rho-controlling window */
GLOB void gfhtControlRho(void);  /*  the main drawing func */
GLOB void gfhtSetupRhoParmWindow(void);
GLOB void gfhtRhoParmClick(int button, int state, int x, int y);

GLOB void gfhtSetupLeafNumParmWindow(void);
GLOB void gfhtNumLeavesParmClick(int button, int state, int x, int y);

/*  initialization functions for window defs and such */
GLOB void gfhtPopSizeExtraFunc(void);


GLOB void gfhtPopSizeKeyboardFunc(unsigned char key, int x, int y);



GLOB void StrokeString(char *s, GLfloat h, GLfloat x, GLfloat y,  int On, 
				GLfloat r, GLfloat WoH);


GLOB void gfhtHandleNewRho(double NewRho);
