



#define UN_EXTERN
/* #define PROFILE_IT */

#ifdef PROFILE_IT
	#include <profiler.h>
#endif


#include "ranlib.h"
#include "HapType.h"
#include "HapTypeAnal.h"
#include "MathStatRand.h"

#include "GFMCMC.h"
#include "GFMCMC_DrawingUtilities.h"

#include "GLUT_for_HapType.h"
#include "ECA_MemAlloc.h"

#include <stdlib.h>
#include <stdio.h>
#include <math.h>







/*  set all the averages on the hap type analysis to zero */
void gfmUserDefd_ResetAllAverages(void)
{
	InitHapTypeAnalToZero(gH);
	
	/*  and, of course, set the gCtr to zero */
	gCtr = 0;
	
}



/*  since we don't have a chain, this doesn't really initialize anything, so */
/*  we will just return without doing anything */
void gfmUserDefd_InitializeChain(void)
{
	return;
}





void gfmUserDefd_OneStepByGlobals(void)
{
	
		/*  if we have changed the number of leaves, we change it back  */
		/*  briefly in order to destroy the tree properly */
/* 		if(gNewNumLeavesRequested == 1)  { */
/* 			gP->NumLeaves = gOldNumLeaves; */
/* 		} */
		if(gA != NULL)
			Destroy_AR_graph(gA);
			
			
		/*  then we change the leaf number back to the new value */
		if(gNewNumLeavesRequested == 1)  {
			gP->NumLeaves = gNewNumLeaves;
			gNewNumLeavesRequested = 0;

				
		}
		
		gA = NewAR_graph(gP);
		MapNodesWPos(gA,0.0);  /*  just do this this in order to set the positions of the leaves */
		MapNodesGivenLeaves(gA);
		gCtr++;
		AccumulateAR_graph(gA, gH);

		
		if(gCtr > 0 && gCtr % 100 == 0) 
			PrintAnalysis(gH,gCtr);
	
	#ifdef PROFILE_IT
		/*  after doing 1000 trees, terminate the profiler and have it dump its info */
		if(gCtr == 1000)
			ProfilerTerm();
	#endif
	
}




#define GFHT_RECT_SCENE  gsAXES_POS_QUADRANT gsXTICKS_MAJOR_SIZE(0.0) gsY_MAJOR_NUM(8) gsNO_XAXIS_NUMS
void gfmUserDefd_DefineWindows(void)
{

	gsOUTPUT_FILE_PREFIX("ChromoSeg");

	gsCONSOLE("HapType Console Window")
		gsDRAW_FUNC(gfhtDrawConsoleWindow)
		
		
	gsNEW_WINDOW(1,"Trees Flying By")
		gsDRAW_FUNC(gfhtDrawMainScene)
		
		gsXLO(gP->Lo - .04 * (gP->Hi - gP->Lo) )
		gsXHI(gP->Hi + .04 * (gP->Hi - gP->Lo))
		gsYHI(1.8f)
		
		
		
	if(gP->pc != NULL) {  /*  only invoke this window if there is a pop-growth container */
		gsNEW_WINDOW(2,"Populations Size History")
			gsDRAW_FUNC(gfhtDrawPopSizes)
			
			gsEXTRA_FUNC(gfhtPopSizeExtraFunc)
			gsKEYBOARD_FUNC(gfhtPopSizeKeyboardFunc)
			
			gsXLO(-.1 * (gP->pc->P[gP->pc->Num-1].t * 2.0) )
			gsXHI(1.1 * (gP->pc->P[gP->pc->Num-1].t * 2.0) )
			gsYLO(-.1 * gP->pc->MaxN)
			gsYHI(1.1 * gP->pc->MaxN)
			
			gsAXES_POS_QUADRANT
	}

		
	gsNEW_WINDOW(3,"Length To First Recombination")
		gsDRAW_FUNC(gfhtDrawWaitingToFirstRecomb)
		
		gsNUM_COLOR_KEYS(&gH->Xk_dist->NumNames)
		gsCOLOR_KEYS(gH->Xk_dist->Names)
		gsXLO( -.15f  * (GLfloat)gH->Xk_dist->MaxPoint)
		gsXHI(1.15f  * (GLfloat)gH->Xk_dist->MaxPoint)
		gsYLO( -.15f  * (GLfloat)gH->Xk_dist->MaxDensity)
		gsYHI(1.15f  * (GLfloat)gH->Xk_dist->MaxDensity)
		
		gsAXES_POS_QUADRANT
		
		
	gsNEW_WINDOW(4,"Prob Second Tree Is Higher")
		gsNUM_COLOR_KEYS(&gH->Xk_dist->NumNames)
		gsCOLOR_KEYS(gH->Xk_dist->Names)
		gsDRAW_FUNC(gfhtDrawProbTree2Higher)
		
		GFHT_RECT_SCENE
	
	
	gsNEW_WINDOW(5,"Num Recombs In Ancestral Material")
		gsDRAW_FUNC(gfhtNumVisiBreaks)
		
		gsYLO(-.1 * (GLfloat)gH->E->E_Num_VBs)
		gsYHI(1.5 * (GLfloat)gH->E->E_Num_VBs)
		
		GFHT_RECT_SCENE
		
		
	gsNEW_WINDOW(6,"Num Shifts Between MRCAs")
		gsDRAW_FUNC(gfhtNumShiftsBetweenMRCAs)
		
		gsYLO(-.1 * (GLfloat)gH->E->E_NumShifts)
		gsYHI(1.5f * (GLfloat)gH->E->E_NumShifts)
		
		GFHT_RECT_SCENE
		
	gsNEW_WINDOW(7,"Rho Parameter Window")
		gsDRAW_FUNC(gfhtControlRho)
		gsXHI(100.0f)
		gsXLO(-100.0 * .1f)
		
		gsAXES_POS_QUADRANT
		gsYTICKS_MAJOR_SIZE(0.0f)
		gsNO_YAXIS_NUMS
		gsY_AXIS_HI(1.0f)
		gsEXTRA_FUNC(gfhtSetupRhoParmWindow)
		
	gsNEW_WINDOW(8,"Leaf Num Parameter Window")
		gsDRAW_FUNC(gfhtControlNumLeaves)
		gsXHI(100.0f)
		gsXLO(-100.0 * .1f)
		
		gsAXES_POS_QUADRANT
		gsYTICKS_MAJOR_SIZE(0.0f)
		gsNO_YAXIS_NUMS
		gsY_AXIS_HI(1.0f)
		gsEXTRA_FUNC(gfhtSetupLeafNumParmWindow)
		
	gsNEW_WINDOW(9,"Zoomable Tree")
		gsDRAW_FUNC(gfhtZoomableTree);
		
		
		
		
		
		

}


void gfmUserDefd_DefineMenus(void)    /*  to define menus for the right click of the mouse */
{
	return;  /*  no special right click menus for now */
}


void gfmUserDefd_LastWords(void)
{
	return;  /*  no special last words here */
}

void gfhtControlRho(void)
{
	int CW = glutGetWindow();
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;
	
	gfmDrawXYAxes();
	
	/*  then draw a line of unit length where rho is in the first series color */
	glColor3fv(CS->Series[0]);
	glBegin(GL_LINES);
		glVertex2f((GLfloat)gP->rho, 0.0f);
		glVertex2f((GLfloat)gP->rho, 1.0f);
	glEnd();
}


void gfhtControlNumLeaves(void)
{
	int CW = glutGetWindow();
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;
	
	gfmDrawXYAxes();
	
	/*  then draw a line of unit length where rho is in the first series color */
	glColor3fv(CS->Series[0]);
	glBegin(GL_LINES);
		glVertex2f((GLfloat)gP->NumLeaves, 0.0f);
		glVertex2f((GLfloat)gP->NumLeaves, 1.0f);
	glEnd();
}


void gfhtSetupLeafNumParmWindow(void)
{
	glutMouseFunc(gfhtNumLeavesParmClick);
}


void gfhtSetupRhoParmWindow(void)
{
	glutMouseFunc(gfhtRhoParmClick);
	/* glutMotionFunc(gfhtRhoParmActiveMotion); */
}

void gfhtRhoParmClick(int button, int state, int x, int y)
{
	GLfloat X,Y;
	
	if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN && glutGetModifiers() == GLUT_ACTIVE_SHIFT) {
		X = gfmReturnXCoord(x);
		Y = gfmReturnYCoord(y);
		
		
		if(Y >= 0.0f && Y <= 1.0f && X > 0.0f)  { /*  if the click is in the right place,  */
													/*  change the value of rho */
			gfhtHandleNewRho(X);
			
			
		}
		if(Y >= 0.0f && Y <= 1.0f && X < 0.0f)
			gfhtHandleNewRho(0.0);
	}
}


void gfhtNumLeavesParmClick(int button, int state, int x, int y)
{
	GLfloat X,Y;
	
	if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN && glutGetModifiers() == GLUT_ACTIVE_SHIFT) {
		X = gfmReturnXCoord(x);
		Y = gfmReturnYCoord(y);
		
		
		if(Y >= 0.0f && Y <= 1.0f && X > 2.0f)  { /*  if the click is in the right place,  */
												/*  change the value of rho */
			
			gOldNumLeaves = gP->NumLeaves;
			gNewNumLeaves = (int)X;
			gfhtHandleNewRho(gP->rho);			/*  this is lazy---resetting everything using this function */
												/*  but it will work for now */
			gNewNumLeavesRequested = 1;
			gDoASingleSweep = 1;  /*  mark it for a single  sweep, at least.   */
								  /*  This way, if it is stopped, it still makes a change */
		}
		if(Y >= 0.0f && Y <= 1.0f && X < 2.0f)  {
			gOldNumLeaves = gP->NumLeaves;
			gNewNumLeaves = 2;
			gfhtHandleNewRho(gP->rho);
			
			gNewNumLeavesRequested = 1;
			
			gDoASingleSweep = 1;  /*  mark it for a single  sweep, at least.   */
								  /*  This way, if it is stopped, it still makes a change */
		}
	}
	
	
}

void gfhtNumShiftsBetweenMRCAs(void)
{
	GLfloat h,x=.05f,w=.45f, cap = .05f;
	ColorScheme3f *CS = gWindowsSettings[glutGetWindow()]->ColorScheme;
	
	/*  draw the theoretical value */
	h = (GLfloat)gH->E->E_NumShifts;
	
	glColor3fv(CS->Series[0]);
	glRectf(x,0.0f,x+w,h);
	
	/*  then draw the simulated value */
	h = (GLfloat)gH->ShiftsBetweenMRCAs->Ave;
	
	glColor3fv(CS->Series[1]);
	glRectf(x+w,0.0f,x+w+w,h);
	
	/*  and put a little standard deviation bar on it too */
	glColor3fv(CS->Axes);  /*  make the SD bars in the axis color */
	x = x + w;   /*  put it right between the two columns */
	glBegin(GL_LINES);
		/*  draw the vertical part from 1.96 SD's above and below current value */
		glVertex2f(x,h - (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		glVertex2f(x,h + (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		
		/*  draw the top cap */
		glVertex2f(x-cap,h - (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		glVertex2f(x+cap,h - (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		
		/*  draw the bottom cap */
		glVertex2f(x-cap,h + (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		glVertex2f(x+cap,h + (GLfloat)sqrt(gH->ShiftsBetweenMRCAs->Var) * 1.96f);
		
	glEnd();

	/*  then draw the axes */
	gfmDrawXYAxes();
	
	/*  set the fitting extrema if necessary */
	gsHANDLE_EXTREMA(0,1,0,1.6f * (GLfloat)gH->E->E_NumShifts);
	
	glColor3fv(gWindowsSettings[glutGetWindow()]->ColorScheme->Series[5]);
	gfnhDrawNotValid();
}


void gfhtNumVisiBreaks(void)
{
	GLfloat h,x=.05f,w=.45f, cap = .05f;
	ColorScheme3f *CS = gWindowsSettings[glutGetWindow()]->ColorScheme;
	
	/*  draw the theoretical value */
	h = (GLfloat)gH->E->E_Num_VBs;
	
	glColor3fv(CS->Series[0]);
	glRectf(x,0.0f,x+w,h);
	
	/*  then draw the simulated value */
	h = (GLfloat)gH->NumVisiBreaks->Ave;
	
	glColor3fv(CS->Series[1]);
	glRectf(x+w,0.0f,x+w+w,h);
	
	/*  and put a little standard deviation bar on it too */
	glColor3fv(CS->Axes);  /*  make the SD bars in the axis color */
	x = x + w;   /*  put it right between the two columns */
	glBegin(GL_LINES);
		/*  draw the vertical part from 1.96 SD's above and below current value */
		glVertex2f(x,h - (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		glVertex2f(x,h + (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		
		/*  draw the top cap */
		glVertex2f(x-cap,h - (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		glVertex2f(x+cap,h - (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		
		/*  draw the bottom cap */
		glVertex2f(x-cap,h + (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		glVertex2f(x+cap,h + (GLfloat)sqrt(gH->NumVisiBreaks->Var) * 1.96f);
		
	glEnd();

	
	/*  then draw the axes */
	gfmDrawXYAxes();
	
	/*  set the fitting extrema if necessary */
	gsHANDLE_EXTREMA(0,1,0,1.6f * (GLfloat)gH->E->E_Num_VBs);
	
	glColor3fv(gWindowsSettings[glutGetWindow()]->ColorScheme->Series[5]);
	gfnhDrawNotValid();
}


void gfhtDrawProbTree2Higher(void)
{
	GLfloat h,x=.05f,w=.45f,cap=.05f;
	ColorScheme3f *CS = gWindowsSettings[glutGetWindow()]->ColorScheme;
	GLfloat true_sd;
	
	/*  draw the theoretical value */
	h = (GLfloat)gH->E->PrHi_less_H2;
	
	/*  compute the true sd from the binomial distribution */
	true_sd = sqrt((h * (1.0f - h) ) / (GLfloat)gH->ProbTree2Higher->NumAved );
	
	glColor3fv(CS->Series[0]);
	glRectf(x,0.0f,x+w,h);
	
	/*  then draw the simulated value */
	h = (GLfloat)gH->ProbTree2Higher->Ave;
	
	glColor3fv(CS->Series[1]);
	glRectf(x+w,0.0f,x+w+w,h);
	
	/*  and put a little standard deviation bar on it too */
	glColor3fv(CS->Axes);  /*  make the SD bars in the axis color */
	x = x + w;   /*  put it right between the two columns */
/*	glBegin(GL_LINES);  */
		/*  draw the vertical part from 1.96 SD's above and below current value */
/*		glVertex2f(x,h - sqrt(gH->ProbTree2Higher->Var) * 1.96f);
		glVertex2f(x,h + sqrt(gH->ProbTree2Higher->Var) * 1.96f);
*/		
		/*  draw the top cap */
/*		glVertex2f(x-cap,h - sqrt(gH->ProbTree2Higher->Var) * 1.96f);
		glVertex2f(x+cap,h - sqrt(gH->ProbTree2Higher->Var) * 1.96f);
*/		
		/*  draw the bottom cap */
/*		glVertex2f(x-cap,h + sqrt(gH->ProbTree2Higher->Var) * 1.96f);
		glVertex2f(x+cap,h + sqrt(gH->ProbTree2Higher->Var) * 1.96f);
		
	glEnd();
*/

	/*  for the standard dev bar we can just use the binomial variance */
	glColor3fv(CS->Series[5]);  /*  make this a different color than the other */
								/*  SD bars */
	h = (GLfloat)gH->E->PrHi_less_H2;  /*  fix the center of the bar at the theoretical prob. */
	glBegin(GL_LINES);
		/*  draw the vertical part from 1.96 SD's above and below current value */
		glVertex2f(x,h - true_sd * 1.96f);
		glVertex2f(x,h + true_sd * 1.96f);
		
		/*  draw the top cap */
		glVertex2f(x-cap,h - true_sd * 1.96f);
		glVertex2f(x+cap,h - true_sd * 1.96f);
		
		/*  draw the bottom cap */
		glVertex2f(x-cap,h + true_sd * 1.96f);
		glVertex2f(x+cap,h + true_sd * 1.96f);
		
	glEnd();
	
	/*  then draw the axes */
	gfmDrawXYAxes();
	
	/*  set the fitting extrema if necessary */
	gsHANDLE_EXTREMA(0,1,0,1.6f * (GLfloat)gH->E->PrHi_less_H2);
	
	glColor3fv(gWindowsSettings[glutGetWindow()]->ColorScheme->Series[5]);
	gfnhDrawNotValid();
	
}

void gfhtZoomableTree()
{
	int CW = glutGetWindow();
	
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;
	GLfloat X = gWindowsSettings[CW]->XCoord;
	clipping_struct TH; /*  a clipping struct FOR THE TREE in which the top is the height of the tree */
						  
		
/*	  set TH here so each tree appears to be the same height
	TH.xlo = Cl->xlo + (.3 * SpanW);
	TH.xhi = Cl->xhi - (.1 * SpanW);
	
	TH.ylo = Cl->ylo + (.3 * SpanH);
	TH.yhi = Cl->ylo + (.3 * SpanH) + 1.0;
*/

	TH.xlo = 0.0f;
	TH.xhi = 1.0f;
	TH.ylo = 0.0f;
	TH.yhi = 1.0f;
	
	gfhtDrawARG_seg(gA,gA->Pars->Lo,gA->Pars->Hi,  CS->Axes[0], CS->Axes[1], CS->Axes[2], &TH);
	if(X > gA->Pars->Lo && X < gA->Pars->Hi) {
		gfhtDrawARG_point(gA,X,CS->Series[0][0], CS->Series[0][1], CS->Series[0][2],&TH);
	}	
	

	glutSwapBuffers();
	
	
}


void gfhtDrawMainScene()
{
	int CW = glutGetWindow();
	char Str[300],Reps[40];
	
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;
	GLfloat X = gWindowsSettings[CW]->XCoord;
	clipping_struct *Cl = gWindowsSettings[CW]->Clips;
	
	clipping_struct TIS;  /*  a clipping struct whose x and y elements will determine where */
						  /*  the tree fits into. This one is for fitting the whole tree into  */
						  /*  the screen */
	clipping_struct TH; /*  a clipping struct FOR THE TREE in which the top is the height of the tree */
	GLfloat SpanW = Cl->xhi - Cl->xlo,
			SpanH = Cl->yhi - Cl->ylo;
	void *Font = GLUT_BITMAP_HELVETICA_10;
			
			
	/*  a hack to get the bitmap sizes easily changed */
	/*  set the font sizes */
	switch(gWindowsSettings[CW]->Legend->FontSize) {
		case(0):
			Font = GLUT_BITMAP_HELVETICA_10;
			break;
		case(1):
			Font = GLUT_BITMAP_HELVETICA_12;
			break;
		case(2):
			Font = GLUT_BITMAP_HELVETICA_18;
			break;
	}
	
						  
	/*  set the area that the tree will fit into: */
	TIS.xlo = Cl->xlo + (.3f * SpanW);
	TIS.xhi = Cl->xhi - (.1f * SpanW);
	
	TIS.ylo = Cl->ylo + (.3f * SpanH);
	TIS.yhi = Cl->yhi - (.1f * SpanH);
	
	/*  deal with the tree scaling in which the height reflects the true height of the tree. */
	TH.xlo = Cl->xlo + (.3f * SpanW);
	TH.xhi = Cl->xhi - (.1f * SpanW);
	
	TH.ylo = Cl->ylo + (.3f * SpanH);
	TH.yhi = Cl->ylo + (.3f * SpanH) + (GLfloat)gA->Root->time;
	
	/*  try changing it back here so each tree appears to be the same height */
	TH.xlo = Cl->xlo + (.3f * SpanW);
	TH.xhi = Cl->xhi - (.1f * SpanW);
	
	TH.ylo = Cl->ylo + (.3f * SpanH);
	TH.yhi = Cl->ylo + (.3f * SpanH) + 1.0f;
	
	/*  now, here is a wacky thing---set the window height so that the tallest tree so far will */
	/*  just fit in it with about 10% hanging over the top. */
	if(gTallestTree < gA->Root->time) {
		gTallestTree = gA->Root->time;
	}
	
	/*  now that we have the max tree height we can set the window height to be about 10% above that */
/* 	Cl->yhi = Cl->ylo + (.3 * SpanH) + (1.1) * gTallestTree; */
	
	/*  and now don't forget to reset the clipping volume */
/* 	gfmClipOrtho(); */
	
	
		
	/*  draw the mouse position and the number of trees */
	sprintf(Str,"X = %f",X);
	sprintf(Reps,"Num Trees = %d",gCtr);
	
	
	glColor3fv(CS->Text);
	if(X>gP->Lo && X<gP->Hi)
		gfmRenderBitmapString(  Cl->xlo + .005f * (Cl->xhi - Cl->xlo),
							Cl->yhi - .1f * (Cl->yhi - Cl->ylo),Font,Str);
	gfmRenderBitmapString(  Cl->xlo + .005f * (Cl->xhi - Cl->xlo),
							Cl->yhi - .15f * (Cl->yhi - Cl->ylo),Font,Reps);
							
	sprintf(Str,"Top = %.3f",gTallestTree);
	gfmRenderBitmapString(  Cl->xlo + .005f * (Cl->xhi - Cl->xlo),
							Cl->yhi - .2f * (Cl->yhi - Cl->ylo),Font,Str);
							
	
	
	
/* 	gfhtDrawMappedARG_rect(gA);  // this is just included to see if we are generating any branches */
							 /*  that aren't really active. */
/* 												R	  G		 B */
	gfhtDrawARG_seg(gA,gA->Pars->Lo,gA->Pars->Hi,  CS->Axes[0], CS->Axes[1], CS->Axes[2], &TH);
	if(X > gA->Pars->Lo && X < gA->Pars->Hi) {
		gfhtDrawARG_point(gA,X,CS->Series[0][0], CS->Series[0][1], CS->Series[0][2],&TH);
	}	
	
	gfhtDrawSlashes(Cl->ylo + (.1f * SpanH)-0.45f * (.05f * SpanH),0.5f * (.05f * SpanH),gA->AllBreaks,gA->NumAllBreaks);
	gfhtDrawSegRectangles(Cl->ylo + (.1f * SpanH),.05f * SpanH,(GLfloat)gA->Pars->Lo,(GLfloat)gA->Pars->Hi,gA->VisiBreaks,gA->NumVisiBreaks);

	glutSwapBuffers();
	
	
}


void gfhtDrawConsoleWindow(void)
{
	char temp[250];
	int CW = glutGetWindow();	
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;

	
	
	glColor3fv(CS->Text);
	gfmRenderBitmapString(-.1f,1.0f,GLUT_BITMAP_HELVETICA_12, "Program: ChromoSeg");
	gfmRenderBitmapString(-.1f,.9f,GLUT_BITMAP_HELVETICA_12, "Author: E.C. Anderson");
	
	sprintf(temp,"NumLeaves: %d", gP->NumLeaves);
	gfmRenderBitmapString(-.1f,.8f,GLUT_BITMAP_HELVETICA_12, temp);
	
	sprintf(temp,"Rho: %f",gP->rho);
	gfmRenderBitmapString(-.1f,.7f,GLUT_BITMAP_HELVETICA_12, temp);
	
	sprintf(temp,"Left EndPt: %.3f",gP->Lo);
	gfmRenderBitmapString(-.1f,.6f,GLUT_BITMAP_HELVETICA_12, temp);
	
	sprintf(temp,"Rt EndPt: %.3f",gP->Hi);
	gfmRenderBitmapString(-.1f,.5f,GLUT_BITMAP_HELVETICA_12, temp);
	
	sprintf(temp,"Seg Length: %.3f",gP->Hi - gP->Lo);
	gfmRenderBitmapString(-.1f,.4f,GLUT_BITMAP_HELVETICA_12, temp);
	
	sprintf(temp,"Trees Generated: %d",gCtr);
	gfmRenderBitmapString(-.1f,.3f,GLUT_BITMAP_HELVETICA_12, temp);
	
	if(gGo) 
		sprintf(temp,"RUNNING!");
	else 
		sprintf(temp,"STOPPED!");
		
	gfmRenderBitmapString(-.1f,.2f,GLUT_BITMAP_HELVETICA_12, temp);
}


/*  executes the OpenGL commands to print the ancestral recombination graph, including */
/*  ALL of the branches, whether or not they are active for any particular position on */
/*  the chromosome.  Currently it just draws it in the 1 x 1 box.  Will change that later. */
/*  This does this by drawing the the two nodes below each coalescent event, and then the */
/*  single node below each recombination node.  Do this by cycling through the EventsArray */
/*  THIS VERSION MAKES THE BLOCKY-RECTANGULAR TYPE OF TREE */
void gfhtDrawMappedARG_rect(AR_graph_struct *A) 
{
	int i;
	char tempStr[100];
	
	CYC_EVENTS(i,A)
		if(A->Events[i]->type == Coalesce) {
			 glBegin(GL_LINES);
			   glColor3f(BARNEY);                                      /*  draw the top horizontal piece */
			   	glVertex3f(A->Events[i]->P[Left][0],
			    			A->Events[i]->Pos[1], 0.0f);
			    glVertex3f(A->Events[i]->P[Right][0],
			    			A->Events[i]->Pos[1], 0.0f);
			    glVertex3f(A->Events[i]->P[Left][0], A->Events[i]->Pos[1],0.0f);   /*  Draw left branch */
			    glVertex3f(A->Events[i]->P[Left][0],
			    			A->Events[i]->Br[Left]->bottom->Pos[1], 0.0);
			    glVertex3f(A->Events[i]->P[Right][0], A->Events[i]->Pos[1],0.0);   /*  Draw right branch */
			    glVertex3f(A->Events[i]->P[Right][0],
			    			A->Events[i]->Br[Right]->bottom->Pos[1], 0.0);
		  	glEnd();
		}
		else if(A->Events[i]->type == Recomb)  {
			glBegin(GL_LINES);
			   glColor3f(BARNEY);    /*  draw the horizontal bottom piece */
			   	glVertex3f(A->Events[i]->P[Left][0],
			    			A->Events[i]->Pos[1], 0.0);
			    glVertex3f(A->Events[i]->P[Right][0],
			    			A->Events[i]->Pos[1], 0.0);

			    glVertex3f(A->Events[i]->P[Middle][0], A->Events[i]->Pos[1],0.0);   /*  Draw middle branch */
			    glVertex3f(A->Events[i]->P[Middle][0],
			    			A->Events[i]->Br[Middle]->bottom->Pos[1], 0.0);
		  	glEnd();
		  	
		  	sprintf(tempStr,"%.3f",A->Events[i]->x);
		  	gfmRenderBitmapString(A->Events[i]->P[Middle][0],A->Events[i]->Pos[1],
		  			GLUT_BITMAP_TIMES_ROMAN_10,tempStr);
		}
       
	END1CYCLE
}



/*  executes the OpenGL commands to print the ancestral recombination graph, including */
/*  ALL of the branches, whether or not they are active for any particular position on */
/*  the chromosome.  Currently it just draws it in the 1 x 1 box.  Will change that later. */
/*  This does this by drawing the the two nodes below each coalescent event, and then the */
/*  single node below each recombination node.  Do this by cycling through the EventsArray */
/*  THIS VERSION MAKES THE BLOCKY-RECTANGULAR TYPE OF TREE.  This only draws the active part */
/*  between Lo and Hi in the color specified by R, G, and B. */
/*  */
/* 	This version assumes that the tree is passed in to fit in a unit square and then it scales */
/*  it to fit inside a square defined by a clipping struct  */
void gfhtDrawARG_seg(AR_graph_struct *A, double Lo, double Hi, double R, double G, double B, clipping_struct *CL) 
{
	int i;
	double lx,mx,rx,my,ly,ry;
	int Final;
	GLfloat xs,xt,ys,yt;  /*  x-scale, y-scale, x-translate, y-translate */
	
	xs = (CL->xhi - CL->xlo);
	xt = CL->xlo;
	ys = (CL->yhi - CL->ylo);
	yt = CL->ylo;
	
	Final = FinalCoalesce(A,Lo,Hi);
	
	for(i=0;i<=Final;i++)   {
		if(A->Events[i]->type == Coalesce) {
			lx = A->Events[i]->P[Left][0] * xs + xt;
			rx = A->Events[i]->P[Right][0]   * xs + xt;
			mx = A->Events[i]->P[Middle][0]  * xs + xt;
			my = A->Events[i]->Pos[1] * ys + yt;
			ly = A->Events[i]->Br[Left]->bottom->Pos[1] * ys + yt;
			ry = A->Events[i]->Br[Right]->bottom->Pos[1] * ys + yt;
			
			 glBegin(GL_LINES);
			   glColor3f(R, G, B);  
			   	if(BranchIsActive(A->Events[i]->Br[Left],Lo,Hi)  ) {   /*  draw the left top part */
				   	glVertex3f(lx,my,0.0);
				    glVertex3f(mx,my,0.0);
				    
				    glVertex3f(lx,my,0.0);		/*  and the left branch */
				    glVertex3f(lx,ly,0.0);
				}
				if(BranchIsActive(A->Events[i]->Br[Right],Lo,Hi)  ) {   /*  draw the right top part */
				   	glVertex3f(rx,my,0.0);
				    glVertex3f(mx,my,0.0);
				    
				    glVertex3f(rx,my,0.0);		/*  and the right branch */
				    glVertex3f(rx,ry,0.0);
				}
		  	glEnd();
		}
		else if(A->Events[i]->type == Recomb)  {
			lx = A->Events[i]->P[Left][0] * xs + xt;
			rx = A->Events[i]->P[Right][0] * xs + xt;
			mx = A->Events[i]->P[Middle][0] * xs + xt;
			my = A->Events[i]->Br[Middle]->bottom->Pos[1] * ys + yt;
			ly = A->Events[i]->Pos[1] * ys + yt;
			ry = A->Events[i]->Pos[1] * ys + yt;
			glBegin(GL_LINES);
			   glColor3f(R, G, B); 
			   if(BranchIsActive(A->Events[i]->Br[Left],Lo,Hi)) {
			   		glVertex3f(lx,ly,0.0);  /*  draw the left bottom part */
			   		glVertex3f(mx,ly,0.0);
			   } 
			   if(BranchIsActive(A->Events[i]->Br[Right],Lo,Hi)) {
			   		glVertex3f(rx,ry,0.0);  /*  draw the right bottom part */
			   		glVertex3f(mx,ry,0.0);
			   }   
			   if(BranchIsActive(A->Events[i]->Br[Middle],Lo,Hi)) {
			   		glVertex3f(mx,ly,0.0);  /*  draw the middle branch going down */
			   		glVertex3f(mx,my,0.0);
			   } 
		  	glEnd();
		}       
	}
}




/*  draws the ARG, from the MRCA to point X to the leaves */
/*  This follows paths back and sees which branches are active. */
/*  It takes much longer but should be more reliable */
void gfhtDrawARG_point(AR_graph_struct *A, double x, double R, double G, double B, clipping_struct *CL) 
{
	int i;
	double lx,mx,rx,my,ly,ry;
	char tempStr[100];
	int Final;
	int NT = 0;
	GLfloat xs,xt,ys,yt;  /*  x-scale, y-scale, x-translate, y-translate */
	
	xs = (CL->xhi - CL->xlo);
	xt = CL->xlo;
	ys = (CL->yhi - CL->ylo);
	yt = CL->ylo;
	
	
	Final = FindMRCAbyPaths(A, x, NT);
		
	for(i=0;i<=Final;i++)   {
	
/* 		printf("\n"); */
/* 		PrintNode(A->Events[i]); */
		
		if(A->Events[i]->type == Coalesce) {
			lx = A->Events[i]->P[Left][0] * xs + xt;
			rx = A->Events[i]->P[Right][0] * xs + xt;
			mx = A->Events[i]->P[Middle][0] * xs + xt;
			my = A->Events[i]->Pos[1] * ys + yt;
			ly = A->Events[i]->Br[Left]->bottom->Pos[1] * ys + yt;
			ry = A->Events[i]->Br[Right]->bottom->Pos[1] * ys + yt;
			
			if(i==Final) {
				sprintf(tempStr,"MRCA");
				glColor3f(R, G, B);
				gfmRenderBitmapString(mx-.03*xs,my+.02*ys,GLUT_BITMAP_TIMES_ROMAN_24,tempStr);
			}
			
			 glBegin(GL_LINES);
			   glColor3f(R, G, B);  
			   	if(A->Events[i]->Br[Left]->NumThrough[NT] > 0  ) {   /*  draw the left top part */
				   	glVertex3f(lx,my,0.0);
				    glVertex3f(mx,my,0.0);
				    
				    glVertex3f(lx,my,0.0);		/*  and the left branch */
				    glVertex3f(lx,ly,0.0);
				}
				if(A->Events[i]->Br[Right]->NumThrough[NT] > 0  ) {   /*  draw the right top part */
				   	glVertex3f(rx,my,0.0);
				    glVertex3f(mx,my,0.0);
				    
				    glVertex3f(rx,my,0.0);		/*  and the right branch */
				    glVertex3f(rx,ry,0.0);
				}
		  	glEnd();
		}
		else if(A->Events[i]->type == Recomb)  {
			lx = A->Events[i]->P[Left][0] * xs + xt;
			rx = A->Events[i]->P[Right][0] * xs + xt;
			mx = A->Events[i]->P[Middle][0] * xs + xt;
			my = A->Events[i]->Br[Middle]->bottom->Pos[1] * ys + yt;
			ly = A->Events[i]->Pos[1] * ys + yt;
			ry = A->Events[i]->Pos[1] * ys + yt;
			glBegin(GL_LINES);
			   glColor3f(R, G, B); 
			   if(A->Events[i]->Br[Left]->NumThrough[NT] > 0) {
			   		glVertex3f(lx,ly,0.0);  /*  draw the left bottom part */
			   		glVertex3f(mx,ly,0.0);
			   } 
			   if(A->Events[i]->Br[Right]->NumThrough[NT] > 0) {
			   		glVertex3f(rx,ry,0.0);  /*  draw the right bottom part */
			   		glVertex3f(mx,ry,0.0);
			   }   
			   if(A->Events[i]->Br[Middle]->NumThrough[NT] > 0) {
			   		glVertex3f(mx,ly,0.0);  /*  draw the middle branch going down */
			   		glVertex3f(mx,my,0.0);
			   } 
		  	glEnd();
		}
	}
}


void gfhtDrawSlashes(GLfloat Vert, GLfloat Height, double *Values, int Num)
{
	int i;
	
	glBegin(GL_LINES);
		glColor3fv(gWindowsSettings[glutGetWindow()]->ColorScheme->Axes);
		for(i=0;i<Num;i++)  {
			glVertex3f((GLfloat)Values[i],Vert, 0.0);
			glVertex3f((GLfloat)Values[i],Vert+Height, 0.0);
		}
	glEnd();
}



/*  draw the theoretical and simulated distributions of waiting time to first */
/*  recombination point */
void gfhtDrawWaitingToFirstRecomb(void)
{
	int i;
	int CW = glutGetWindow();
	ColorScheme3f *CS = gWindowsSettings[CW]->ColorScheme;
	GLfloat x,y;
	
	glColor3fv(CS->Series[0]);
	glBegin(GL_LINE_STRIP);
		for(i=1;i<gH->Xk_dist->NumPoints;i++)  {
			x = (GLfloat)gH->Xk_dist->Xks[i];
			y = (GLfloat)gH->Xk_dist->Pdf[i];
			glVertex2f(x,y);
		}
	glEnd();
	
	
	/*  then draw the simulated density */
	glColor3fv(CS->Series[1]);
	gfmduDrawOneHistAsCurveWith2Bars(gH->LengthToFirstRecomb,
				  1, GFMDU_NO_STIPPLE, 1);
	
	
	/*  then draw the axes */
	gfmDrawXYAxes();
	
	/*  set the extrema as necessary */
	gsHANDLE_EXTREMA(0.0f,gH->Xk_dist->MaxPoint,0.0,gH->Xk_dist->MaxDensity);

	glColor3fv(gWindowsSettings[glutGetWindow()]->ColorScheme->Series[5]);
	gfnhDrawNotValid();	
}






/*  given an array of doubles in sorted order between 0.0 and End, draw */
/*  rectangles of different colors over one another as in a stacked */
/*  bar chart.  For now the thing will have a fixed width of 1.0, */
/*  so that if End is longer or shorter than 1.0, the whole thing gets */
/*  stretched out.   */
void gfhtDrawSegRectangles(GLfloat Vert, GLfloat Height, GLfloat Lo, GLfloat Hi, double *Values, int Num) 
{
	int g;
	ColorScheme3f *CS = gWindowsSettings[glutGetWindow()]->ColorScheme;
	
	/*  first do the segment from 0.0 to the end */
	glColor3fv(CS->Series[0]);
	glRectf(Lo, Vert, Hi, Vert + Height);
	
	for(g=0;g<Num;g++)  {
		
		glColor3fv(CS->Series[ (g+1) % CS->N]);
		
		glRectf((GLfloat)Values[g], Vert, Hi, Vert + Height);
		
	}
}

void gfhtDrawPopSizes(void)
{
	int CW = glutGetWindow();
	int i;
	GLfloat EventTime;
	
	/*  don't do anything if the popgrowth container is null */
	if(gP->pc == NULL)
		return;
	
	
	/*  and here we have the population size curve */
	glColor3fv(gWindowsSettings[CW]->ColorScheme->Series[0]);
	
	glBegin(GL_LINE_STRIP);
		
		/*  if we are using the PopGrowth thing, then draw the curve */
		if(gP->pc->UsePopGrowth==1) {
			for(i=0;i<NUM_POP_CURVE_POINTS;i++)  {
				glVertex2f((GLfloat)gP->pc->ts[i], (GLfloat)gP->pc->ns[i]);
			}
		}
		/*  otherwise, just draw a line at Nplus.  Make it a long straight line from */
		/*  0.0 to 1000000 times the initial size (that will be plenty long enough to */
		/*  be there for all the coalescent events. */
		else {
			glVertex2f(0.0f,(GLfloat)gP->pc->P[0].Nplus);
			glVertex2f((GLfloat)gP->pc->P[0].Nplus * 1000000.0f, (GLfloat)gP->pc->P[0].Nplus);
		}
	glEnd();
	
						 
	/*  and now, for the final hurrah, we put a colored line at the time of  */
	/*  each coalescence of the current tree, and different colored lines for  */
	/*  each recombination event */
	if(gP->pc != NULL) {
		glBegin(GL_LINES);
			CYC_EVENTS(i,gA)
				EventTime = gA->Events[i]->time * gP->pc->P[0].Nplus * 2.0;
				if(gA->Events[i]->type == Coalesce)
					glColor3fv(gWindowsSettings[CW]->ColorScheme->Series[1]);
				else if(gA->Events[i]->type == Recomb)
					glColor3fv(gWindowsSettings[CW]->ColorScheme->Series[3]);
				else  /*  this is just to catch bugs, it should never get down here though. */
					glColor3fv(gWindowsSettings[CW]->ColorScheme->Series[2]);
				
				glVertex2f(EventTime,0.0);
				glVertex2f(EventTime, (GLfloat)gP->pc->MaxN);
			END1CYCLE
		glEnd();
	}
	
	/*  finally, draw the axes */
	gfmDrawXYAxes();
	
}

void gfhtPopSizeExtraFunc(void)
{
	glutMotionFunc(gfmMouseLocation);
}



/*
	For rendering a string in the proportional roman font 
		s		->  the string to be rendered
		h		->  the height (top to bottom) of the max-height xter (in the alphabet) in real units 
		x		->  x coordinate in the plane
		y		->  y coordinate in the plane where the bottom-line of the text should be
		On		->  how the text is to be aligned:
						0	->  left edge of first letter
						1	->  center of first letter
						2	->  center of the string
						3	->  center of last letter
						4	->  right edge of last letter
		r		->  the rotation angle for the text itself.  0 is horizontal to the right
					and 90 degrees is straight down.
		WoH		->  "width over height" and aspect ratio of sorts 
	
*/
void StrokeString(char *s, GLfloat h, GLfloat x, GLfloat y,  int On, 
				GLfloat r, GLfloat WoH)
{
	char *c;
	GLfloat flw, llw, sw=0.0;  /*  first letter width, last letter width, string width */
	int Num = 0;  /*  number of characters in string */
	GLfloat sy = h/119.05f, sx = sy / WoH;  /*  scale factors to keep the height correct and */
											/*  the aspect ratio correct as well */
	
	
	/*  first determine the width of everything */
	for (c=s; *c != '\0'; c++) {
		Num++;
		sw += glutStrokeWidth(GLUT_STROKE_ROMAN, (int)(*c));
	}
	flw = glutStrokeWidth(GLUT_STROKE_ROMAN, (int)(s[0]));
	llw = glutStrokeWidth(GLUT_STROKE_ROMAN, (int)(s[Num-1]));
	
	/*  push the current matrix to save it */
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	
	/*  then do the necessary transformations */
	glLoadIdentity();
	glTranslatef(x,y,0.0f);  /*  translate out to the point x,y */
	
	glScalef(sx, sy, 1.0f);	/*  scale the axes for size */
	
	/*  then translate to accommodate the positioning of the text */
	switch(On) {
		case(1):
			glTranslatef(-flw * .5f, 0.0f, 0.0f);
			break;
		case(2):
			glTranslatef(-sw * .5f, 0.0f, 0.0f);
			break;
		case(3):
			glTranslatef(-sw + (.4f * llw),0.0f,0.0f);
			break;
		case(4):
			glTranslatef(-sw,0.0f,0.0f);
			break;
	}
	
	glRotatef(r,0.0f,0.0f,-1.0f);  /*  rotate it around the z-axis */
	
	/*  then lay down the text */
	for (c=s; *c != '\0'; c++) {
		glutStrokeCharacter(GLUT_STROKE_ROMAN, (int)(*c));
	}
	
	/*  then restore whatever matrix was in effect before */
	glPopMatrix();
	
	 
}

/*  when the user asks to change the value of rho, many things must change--- */
/*  the value must be changed, the expected values must be changed, the  */
/*  averages must be reset.  This function takes care of all that */
void gfhtHandleNewRho(double NewRho)
{
	int i;
	
	
	/*  first set the new rho */
	gP->rho = NewRho;
	
	/*  then recompute those expected values */
	ComputeExpectedValues(gP,gH->E);
	
	/*  then recompute the Xk_dist stuff */
	/*  first we free the memory currently in gH->LengthToFirstRecomb */
	/*  because that will get reallocated  OOPS!  I DON'T HAVE A FUNCTION TO DO THAT YET!! */
/* 	FreeDval(gH->LengthToFirstRecomb); */
	ComputeXkDist(gH->Xk_dist,gP, &(gH->LengthToFirstRecomb));
	
	/*  then reset all the averages */
	gfmUserDefd_ResetAllAverages();
	
	/*  and finally, refit windows that will need refitting */
	CYC_WINDOWS(i)
		if(gWindowsArray[i] != NULL)  {  /*  only ask if they need refitting, if they aren't null.  Otherwise it crashes on Windows and Linux */
			if(GFNH_NEEDS_FITTING(i))  {
				gWindowsSettings[i]->Fits->FitToExtremaNow = 1;
			}
		}
	END1CYCLE
}

/*  draws a big NOT VALID warning over the diagnostics that are rendered not */
/*  valid, because the pop size is changing.  Color should be set before entry into the function */
void gfnhDrawNotValid(void)
{
	int CW = glutGetWindow();
	clipping_struct *C = gWindowsSettings[CW]->Clips;
	char temp[200];

	if(gP->pc == NULL)
		return;
		
	if(gP->pc->UsePopGrowth == 1) {
		sprintf(temp,"NOT VALID FOR");
		gfmStrokeString(temp, .20f * (C->yhi - C->ylo), C->xlo,.6f * (C->yhi - C->ylo),
						0,0.0f,1.4f * gfmWoH());
		
		sprintf(temp,"Changing Pop Size");
		gfmStrokeString(temp, .20f * (C->yhi - C->ylo), C->xlo,.1f * (C->yhi - C->ylo),
						0,0.0f,1.4f * gfmWoH());
	}
	
	
}

/*  special function for the popsize window. Hitting 0 in that window will */
/*  cause one to no longer use the popsize info, and will give a  */
/*  no-growth population of size InitPopSize (whatever was the initial */
/*  pop size int the popgrowth container.  Hitting 1 will re-instantiate */
/*  the popgrowth parameters.  These two (0 and 1) override any default  */
/*  actions of those two keys, but we have have all the other defaults */
/*  in there, too. */
void gfhtPopSizeKeyboardFunc(unsigned char key, int x, int y)
{
	if(gP->pc != NULL) {  /*  if there is a popgrowth container, deal with 0 and 1 */
		switch(key) {
			case(48):
				gP->pc->UsePopGrowth = 0;
				gfmUserDefd_ResetAllAverages();
				return;   /*  return here and three lines down causes the override of any */
						  /*  defaults */
			case(49):
				gP->pc->UsePopGrowth = 1;
				gfmUserDefd_ResetAllAverages();
				return;
		}
	}
	
	/*  now we put the other keyboard functions in here too. */
	gfmProcessNormalKeys(key,x,y);
	
}

int main(int argcp, char **argv)
{
	parm_struct *P;
	AR_graph_struct *A;
/* 	long seed1, seed2; */
	haptype_anal_struct *H;
	double Points[] = {.1,.2,.3,.4,.5,.6,.7,.8,.9};
	popgrowth_input_struct *PIP;
	
	P = (parm_struct *)malloc(sizeof(parm_struct));

	
	PIP = ReadPopGrowthFile("PopGrowthPars.txt");
	P->pc = ProcessPopGrowth(PIP);

	P->pc->UsePopGrowth = 0;

/*	
	PrintPopGrowth(P->pc);
	
	scanf("%d",&boing);
	for(th=0.0;th<150000;th+=100)
		printf("\nth = %.3f      t = %.3f   back to th = %.3f",th, T_From_Th(P->pc,th,1.0)  ,
				Th_From_T(P->pc, T_From_Th(P->pc,th,1.0),1.0 ) );
	
	scanf("%d",&boing);
	printf("\n\nTime\t\tPopSize");
	for(i=0;i<NUM_POP_CURVE_POINTS;i++)  {
		printf("\n%.2f\t\t%.2f",P->pc->ts[i],P->pc->ns[i]);
	}
	
	return(0);
*/

	/*  initialize some globals */
/* 	gLo = 0.0; */
/* 	gHi = 0.0; */
	gMem.NS_ctr = 0;
	gMem.BS_ctr = 0;
	gCtr = 0;
	

gNewNumLeavesRequested = 0;	
		
	
/* 	printf("\nEnter the number of leaves->"); */
/* 	scanf("%d",&(P->NumLeaves)); */
P->NumLeaves = 2;
	
/* 	printf("\nEnter a value for rho->"); */
/* 	scanf("%lf",&(P->rho)); */
P->rho = 10.0;	
	
/* 	printf("\nGive me a Lo and  Hi->"); */
/* 	scanf("%lf%lf",&(P->Lo), &(P->Hi) ); */
P->Lo = 0.0;
P->Hi = 1.0;

	P->L = P->Hi - P->Lo;
	
/* 	printf("\n\nEnter two ints to seed the RNG"); */
/* 	scanf("%d%d",&seed1, &seed2); */
/* 	setall(seed1,seed2); */

	/*  go through it once to set all the memory, etc. */
	H = AllocHapTypeAnal(P, 9,Points);
	
	
	A = NewAR_graph(P);
	
	
	MapNodesWPos(A,0.0);  /*  just do this this in order to set the positions of the leaves */
	
	
	MapNodesGivenLeaves(A);
	

/*	
	for(i=0;i<100000000;i++) {
		NoGraphicsSweep(A,H,P);
		if(i%250 == 0)  {
			printf("\nRep %d",i);
			PrintAnalysis(H,i);
		}
	}
	
	return(0);
*/	

	
	/*  make the stupid global pointer point to where it ought to */
	gA = A;
	gH = H;
	gP = P;
	
	
/**************************************************	
for(i=0;i<1000;i++) 	{
	
		//  if we have changed the number of leaves, we change it back 
		//  briefly in order to destroy the tree properly 
		if(gNewNumLeavesRequested == 1)  {
			gP->NumLeaves = gOldNumLeaves;
		}
		if(gA != NULL)
			Destroy_AR_graph(gA);
			
printf("\ndestroyed");
			
			
		//  then we change the leaf number back to the new value
		if(gNewNumLeavesRequested == 1)  {
			gP->NumLeaves = gNewNumLeaves;
			gNewNumLeavesRequested = 0;
		}
		
		gA = NewAR_graph(gP);
printf("\nmade new");
// 		MapNodesWPos(gA,0.0);  // just do this this in order to set the positions of the leaves
// 		MapNodesGivenLeaves(gA);
		gCtr++;
//printf("\nmapped nodes");
		AccumulateAR_graph(gA, gH);
printf("\naccumulated graph");
		
		if(gCtr > 0 && gCtr % 100 == 0) 
			PrintAnalysis(gH,gCtr);
			
		printf("\n%d  gCtr = %d",i,gCtr);
	
}

	
	//  INITIALIZE THE PROFILER TO COLLECT RUNNING TIME INFORMATION
	#ifdef PROFILE_IT
		ProfilerInit(0,2,15,5);
	#endif
*******************************************/		
	
	
	
	
	
	
	/*  here must call glutInit from within main, with the command line option */
	/*  pointer, and then call gfmInitGFM, and that does it.   */
	glutInit(&argcp, argv);
	gfmInitGFM();
	
	return(0);
}


